跳转至

1.4.5-1.4.10 版本升级到最新版本

升级及迁移请保持 SECRET_KEY 与旧版本一致, 否则会导致数据库加密数据无法解密

  • 更新前请一定要做好备份 数据库 和 jumpserver 源代码的工作
cp -r /opt/jumpserver /opt/jumpserver_bak
mysqldump -uroot -p jumpserver > /opt/jumpserver_bak.sql

升级步骤

请务必认真详细阅读每一个文字并理解后才能操作升级事宜

请先检查自己各组件的当前版本
本文档仅适合 1.4.5 1.4.6 1.4.7 1.4.8 1.4.9 1.4.10 版本
从 1.4.x 版本开始, mysql 版本需要大于等于 5.6, mariadb 版本需要大于等于 5.5.56
更新配置文件需要把对应旧版本的设置复制到新的配置文件

1. 停止 core

cd /opt/jumpserver
source /opt/py3/bin/activate
./jms stop

自行替换 /opt 为你实际安装目录

2. 更新代码

cd /opt/jumpserver
git fetch
git checkout master
git pull
如果执行 git pull 提示 error, 请按照提示自行处理

提示 error: Your local changes to the following file would be overwritten by merge

git reset --hard
git pull

3. 更新配置文件

mv config.py config.py.bak
cp config_example.yml config.yml
vi config.yml

把旧配置文件 config.py.bak 的相关内容填到新的配置文件 config.yml 里面

请勿照抄, 以下模板仅供参考

# SECURITY WARNING: keep the secret key used in production secret!
# 加密秘钥 生产环境中请修改为随机字符串,请勿外泄, 可使用命令生成
# cat /dev/urandom | tr -dc A-Za-z0-9 | head -c 49;echo
SECRET_KEY: W5Ic3fMXNZ0p5RIy5DhJYJllppTfcfkW8Yuf94VBMfpcssbfu

# SECURITY WARNING: keep the bootstrap token used in production secret!
# 预共享Token coco和guacamole用来注册服务账号,不在使用原来的注册接受机制
BOOTSTRAP_TOKEN: zxffNymGjP79j6BN

# Development env open this, when error occur display the full process track, Production disable it
# DEBUG 模式 开启DEBUG后遇到错误时可以看到更多日志
DEBUG: false

# DEBUG, INFO, WARNING, ERROR, CRITICAL can set. See https://docs.djangoproject.com/en/1.10/topics/logging/
# 日志级别
LOG_LEVEL: ERROR
# LOG_DIR:

# Session expiration setting, Default 24 hour, Also set expired on on browser close
# 浏览器Session过期时间,默认24小时, 也可以设置浏览器关闭则过期
# SESSION_COOKIE_AGE: 86400
SESSION_EXPIRE_AT_BROWSER_CLOSE: true

# Database setting, Support sqlite3, mysql, postgres ....
# 数据库设置
# See https://docs.djangoproject.com/en/1.10/ref/settings/#databases

# SQLite setting:
# 使用单文件sqlite数据库
# DB_ENGINE: sqlite3
# DB_NAME:

# MySQL or postgres setting like:
# 使用Mysql作为数据库
DB_ENGINE: mysql
DB_HOST: 127.0.0.1
DB_PORT: 3306
DB_USER: jumpserver
DB_PASSWORD: rBi41SrDqlX4zsx9e1L0cqTP
DB_NAME: jumpserver

# When Django start it will bind this host and port
# ./manage.py runserver 127.0.0.1:8080
# 运行时绑定端口
HTTP_BIND_HOST: 0.0.0.0
HTTP_LISTEN_PORT: 8080
WS_LISTEN_PORT: 8070

# Use Redis as broker for celery and web socket
# Redis配置
REDIS_HOST: 127.0.0.1
REDIS_PORT: 6379
REDIS_PASSWORD: ZhYnLrodpmPncovxJTnRyiBs
# REDIS_DB_CELERY: 3
# REDIS_DB_CACHE: 4

# Use OpenID authorization
# 使用OpenID 来进行认证设置
# BASE_SITE_URL: http://localhost:8080
# AUTH_OPENID: false  # True or False
# AUTH_OPENID_SERVER_URL: https://openid-auth-server.com/
# AUTH_OPENID_REALM_NAME: realm-name
# AUTH_OPENID_CLIENT_ID: client-id
# AUTH_OPENID_CLIENT_SECRET: client-secret
# AUTH_OPENID_IGNORE_SSL_VERIFICATION: True
# AUTH_OPENID_SHARE_SESSION: True

# Use Radius authorization
# 使用Radius来认证
# AUTH_RADIUS: false
# RADIUS_SERVER: localhost
# RADIUS_PORT: 1812
# RADIUS_SECRET:

# CAS 配置
# AUTH_CAS': False,
# CAS_SERVER_URL': "http://host/cas/",
# CAS_ROOT_PROXIED_AS': 'http://jumpserver-host:port',  
# CAS_LOGOUT_COMPLETELY': True,
# CAS_VERSION': 3,

# LDAP/AD settings
# LDAP 搜索分页数量
# AUTH_LDAP_SEARCH_PAGED_SIZE: 1000
#
# 定时同步用户
# 启用 / 禁用
# AUTH_LDAP_SYNC_IS_PERIODIC: True
# 同步间隔 (单位: 时) (优先)
# AUTH_LDAP_SYNC_INTERVAL: 12
# Crontab 表达式
# AUTH_LDAP_SYNC_CRONTAB: * 6 * * *
#
# LDAP 用户登录时仅允许在用户列表中的用户执行 LDAP Server 认证
# AUTH_LDAP_USER_LOGIN_ONLY_IN_USERS: False
#
# LDAP 认证时如果日志中出现以下信息将参数设置为 0 (详情参见:https://www.python-ldap.org/en/latest/faq.html)
# In order to perform this operation a successful bind must be completed on the connection
# AUTH_LDAP_OPTIONS_OPT_REFERRALS: -1

# OTP settings
# OTP/MFA 配置
# OTP_VALID_WINDOW: 0
# OTP_ISSUER_NAME: Jumpserver

# Perm show single asset to ungrouped node
# 是否把未授权节点资产放入到 未分组 节点中
# PERM_SINGLE_ASSET_TO_UNGROUP_NODE: false
#
# 启用定时任务
# PERIOD_TASK_ENABLE: True
#
# 启用二次复合认证配置
# LOGIN_CONFIRM_ENABLE: False
#
# Windows 登录跳过手动输入密码
WINDOWS_SKIP_ALL_MANUAL_PASSWORD: True

4. 更新依赖

pip install wheel
pip install --upgrade pip setuptools
pip install -r requirements/requirements.txt

如果升级前版本是 1.4.5 请执行下面命令, 不是 1.4.5 请直接看第 5 步启动 core

cd utils
vi 1.4.4_to_1.4.5_migrations.sh
#!/bin/bash
#

host=127.0.0.1  # 修改你的 jumpserver 数据库 ip
port=3306       # 修改你的 jumpserver 数据库端口
username=root
db=jumpserver   # 修改你的 jumpserver 数据库名

echo "备份原来的 migrations"
mysqldump -u${username} -h${host} -P${port} -p ${db} django_migrations > django_migrations.sql.bak
ret=$?

if [ ${ret} == "0" ];then
    echo "开始使用新的migrations文件"
    mysql -u${username} -h${host} -P${port} -p ${db} < django_migrations.sql
else
    echo "Not valid"
fi

5. 启动 core

cd /opt/jumpserver
./jms start

确定启动没有错误

可以 -d 参数在后台运行
./jms start -d  

6. 修改 nginx 配置

vi /etc/nginx/conf.d/jumpserver.conf

修改 jumpserver.conf

server {
    listen 80;

    client_max_body_size 100m;  # 录像及文件上传大小限制

    location /luna/ {
        try_files $uri / /index.html;
        alias /opt/luna/;  # luna 路径, 如果修改安装目录, 此处需要修改
    }

    location /media/ {
        add_header Content-Encoding gzip;
        root /opt/jumpserver/data/;  # 录像位置, 如果修改安装目录, 此处需要修改
    }

    location /static/ {
        root /opt/jumpserver/data/;  # 静态资源, 如果修改安装目录, 此处需要修改
    }

    location /koko/ {
        proxy_pass       http://localhost:5000;
        proxy_buffering off;
        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "upgrade";
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        access_log off;
    }

    location /guacamole/ {
        proxy_pass       http://localhost:8081/;
        proxy_buffering off;
        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection $http_connection;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        access_log off;
    }

    location /ws/ {
        proxy_pass http://localhost:8070;
        proxy_buffering off;
        proxy_http_version 1.1;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "upgrade";
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        access_log off;
    }

    location / {
        proxy_pass http://localhost:8080;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    }
}
nginx -t
nginx -s reload

7. 更新 luna

cd /opt
rm -rf luna luna.tar.gz
wget https://github.com/jumpserver/luna/releases/download/1.5.9/luna.tar.gz
网络有问题访问 此处 快速下载
wget https://github.com/jumpserver/luna/releases/download/1.5.9/luna.tar.gz
tar -xf luna.tar.gz

8. 更新 koko

  • 1.5.2 版本开始 coco 被 koko 取代, 且 coco 后续不再更新, 请手动停止并删除 coco 目录
docker stop jms_koko
docker rm jms_koko
docker run --name jms_koko -d \
  -p 2222:2222 -p 127.0.0.1:5000:5000 \
  -e CORE_HOST=http://<Jumpserver_url> \
  -e BOOTSTRAP_TOKEN=<Jumpserver_BOOTSTRAP_TOKEN> \
  -e LOG_LEVEL=ERROR \
  --restart=always \
  jumpserver/jms_koko:<Tag>
<Jumpserver_url> 为 jumpserver 的 url 地址, <Jumpserver_BOOTSTRAP_TOKEN> 需要从 jumpserver/config.yml 里面获取, 保证一致, <Tag> 是版本

例:

docker run --name jms_koko -d
  -p 2222:2222
  -p 127.0.0.1:5000:5000
  -e CORE_HOST=http://192.168.244.144:8080
  -e BOOTSTRAP_TOKEN=zxffNymGjP79j6BN
  -e LOG_LEVEL=ERROR
  --restart=always
  jumpserver/jms_koko:1.5.9

9. 更新 guacamole

docker stop jms_guacamole
docker rm jms_guacamole
docker run --name jms_guacamole -d
  -p 127.0.0.1:8081:8080
  -e JUMPSERVER_SERVER=http://<Jumpserver_url>
  -e BOOTSTRAP_TOKEN=<Jumpserver_BOOTSTRAP_TOKEN>
  -e GUACAMOLE_LOG_LEVEL=ERROR
  jumpserver/jms_guacamole:<Tag>
<Jumpserver_url> 为 jumpserver 的 url 地址, <Jumpserver_BOOTSTRAP_TOKEN> 需要从 jumpserver/config.yml 里面获取, 保证一致, <Tag> 是版本

例:

docker run --name jms_guacamole -d
  -p 127.0.0.1:8081:8080
  -e JUMPSERVER_SERVER=http://192.168.244.144:8080
  -e BOOTSTRAP_TOKEN=abcdefg1234
  -e GUACAMOLE_LOG_LEVEL=ERROR
  jumpserver/jms_guacamole:1.5.9
  • 升级完成后到 Web 会话管理 - 终端管理 查看组件是否已经在线